=== debian/changelog ===
libyang (1.0.184-2+cl4.3.2u2) unstable; urgency=medium

  * Specifying version to replace for libyang0.16 

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 15 Nov 2023 17:55:32 -0800

libyang (1.0.184-2+cl4.3.2u1) unstable; urgency=medium

  * Adding entry in debian/control to mark libyang1 as replacing libyang0.16
    on an upgrade 

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 15 Nov 2023 13:45:32 -0800

libyang (1.0.184-2+cl4.3.0u1) unstable; urgency=medium

  * upstream 1.0.184 (0.16-r3) release

 -- dev-support <dev-support@cumulusnetworks.com>  Mon, 23 Nov 2020 14:10:41 -0800

libyang (0.16.105-2+cl4.2.1u1) unstable; urgency=medium

  * [cumulus] Build with ENABLE_CACHE=OFF (CM-31452)

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 16 Sep 2020 14:14:43 -0700
