=== debian/control ===
Source: libyang
Section: libs
Homepage: https://netopeer.liberouter.org/
Maintainer: David Lamparter <equinox-debian@diac24.net>
Uploaders: CESNET <rkrejci@cesnet.cz>
Priority: optional
Standards-Version: 4.2.1
Build-Depends:
 bison,
 cmake,
 debhelper (>= 11~),
 dh-python,
 libcmocka-dev <!nocheck>,
 libpcre3-dev,
 swig (>= 3.0.12),
 python3-all-dev,
 python3-all-dbg,
 pkg-config
Vcs-Browser: https://github.com/CESNET/libyang/tree/debian
Vcs-Git: https://github.com/CESNET/libyang.git -b debian

Package: libyang1
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces: libyang0.16 (>= 0.16.105+really)
Breaks: libyang0.16 (>= 0.16.105+really)
Architecture: any
Description: parser toolkit for IETF YANG data modeling - runtime
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 The library is implemented in C and provides an API for other software
 to use in processing configurations.

Package: libyang-dev
Depends:
 ${misc:Depends},
 libpcre3-dev,
 libyang1 (= ${binary:Version})
Section: libdevel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - development files
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 This package contains the C headers, a pkgconfig file, and .so entry point
 for libyang.

Package: yang-tools
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libyang1 (= ${binary:Version})
Section: devel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - executable tools
 This package provides the "yanglint" and "yangre" tools which can be used
 during the creation of IETF YANG schemas.  The tools are not generally
 useful for normal operation where libyang primarily processes configuration
 data, not schemas.

Package: libyang-cpp1
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libyang1 (= ${binary:Version})
Architecture: any
Description: parser toolkit for IETF YANG data modeling - C++ runtime
 Partially SWIG-generated bindings to use libyang with a C++ API.
 The functionality is the same as in libyang, the C++ code links wraps
 and uses libyang C code.

Package: libyang-cpp-dev
Depends:
 ${misc:Depends},
 libyang-cpp1 (= ${binary:Version}),
 libyang-dev (= ${binary:Version})
Section: libdevel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - C++ development files
 Partially SWIG-generated bindings to use libyang with a C++ API.
 The functionality is the same as in libyang, the C++ code links wraps
 and uses libyang C code.
 .
 This is the accompanying development package, containing headers, a
 pkgconfig file, and .so entry point for the libyang C++ bindings.

#Package: python3-yang
#Depends:
# ${misc:Depends},
# ${shlibs:Depends},
# ${python3:Depends},
# libyang-cpp1 (= ${binary:Version})
#Section: python
#Architecture: any
#Description: parser toolkit for IETF YANG data modeling - python3 support
# This package allows using libyang functionality to load IETF YANG models
# and data from Python3 code.
# .
# The bindings are partially generated by SWIG.
#
#Package: python3-yang-dbg
#Depends:
# ${misc:Depends},
# ${shlibs:Depends},
# ${python3:Depends},
# python3-yang (=${binary:Version})
#Section: debug
#Architecture: any
#Description: parser toolkit for IETF YANG data modeling - python3 debug
# This package allows using libyang functionality to load IETF YANG models
# and data from Python3 code.
# .
# This package contains support for debug versions of Python.
