=== debian/changelog ===
libyang (1.0.225-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/tests/control: Remove test for no longer built python3-yang
    (Closes: #989886)

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 23 Jun 2021 22:46:11 +0200

libyang (1.0.225-1) unstable; urgency=medium

  * New upstream release

 -- Ondřej Surý <ondrej@debian.org>  Mon, 08 Mar 2021 15:39:56 +0100

libyang (1.0.215-1) unstable; urgency=medium

  * Remove C++ symbols file, it's mostly impossible to maintain
  * Update the libyang1 symbols file with the new symbol

 -- Ondřej Surý <ondrej@debian.org>  Tue, 02 Mar 2021 14:27:37 +0100
