=== debian/control ===
Source: libyang
Section: libs
Homepage: https://netopeer.liberouter.org/
Maintainer: David Lamparter <equinox-debian@diac24.net>
Uploaders: CESNET <rkrejci@cesnet.cz>,
           Ondřej Surý <ondrej@debian.org>
Priority: optional
Standards-Version: 4.5.0
Build-Depends: bison,
               cmake,
               debhelper (>= 9.20150101),
               libcmocka-dev <!nocheck>,
               libpcre3-dev,
               pkg-config
Vcs-Browser: https://github.com/CESNET/libyang/tree/debian/master
Vcs-Git: https://github.com/CESNET/libyang.git -b debian/master

Package: libyang1
Depends: ${misc:Depends},
         ${shlibs:Depends}
Architecture: any
Description: parser toolkit for IETF YANG data modeling - runtime
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 The library is implemented in C and provides an API for other software
 to use in processing configurations.

Package: libyang-dev
Depends: libpcre3-dev,
         libyang1 (= ${binary:Version}),
         ${misc:Depends}
Section: libdevel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - development files
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 This package contains the C headers, a pkgconfig file, and .so entry point
 for libyang.

Package: libyang-tools
Depends: libyang1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: yang-tools (<< ${source:Version})
Replaces: yang-tools (<< ${source:Version})
Section: devel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - executable tools
 This package provides the "yanglint" and "yangre" tools which can be used
 during the creation of IETF YANG schemas.  The tools are not generally
 useful for normal operation where libyang primarily processes configuration
 data, not schemas.

Package: libyang-cpp1
Depends: libyang1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Architecture: any
Description: parser toolkit for IETF YANG data modeling - C++ runtime
 Partially SWIG-generated bindings to use libyang with a C++ API.
 The functionality is the same as in libyang, the C++ code links wraps
 and uses libyang C code.

Package: libyang-cpp-dev
Depends: libyang-cpp1 (= ${binary:Version}),
         libyang-dev (= ${binary:Version}),
         ${misc:Depends}
Section: libdevel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - C++ development files
 Partially SWIG-generated bindings to use libyang with a C++ API.
 The functionality is the same as in libyang, the C++ code links wraps
 and uses libyang C code.
 .
 This is the accompanying development package, containing headers, a
 pkgconfig file, and .so entry point for the libyang C++ bindings.

Package: yang-tools
Depends: libyang-tools (>= ${source:Version}),
         ${misc:Depends}
Section: oldlibs
Architecture: all
Description: parser toolkit for IETF YANG data modeling [dummy package]
 This is empty dependency package to pull the executable tools.  It's
 safe to remove.
