=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:String="Package" \
		-DENABLE_LYD_PRIV=ON \
		-DGEN_LANGUAGE_BINDINGS=ON \
		-DGEN_JAVA_BINDINGS=OFF \
		-DGEN_JAVASCRIPT_BINDINGS=OFF \
		-DGEN_PYTHON_BINDINGS=OFF

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	make -C obj-$(DEB_HOST_GNU_TYPE) test ARGS=-V
endif
